package ast;

abstract public class Bin extends Exp {

    /** Construct a Binary expression out of two expressions.*/
    public Bin(Exp lhs, Exp rhs) {
        lhs_ = lhs;
        rhs_ = rhs;
    }

    /** The string that represents the operation in concrete syntax.*/
    public abstract String operator();

    /** Print the binary expression.*/
    public void print() {
        System.out.print("(");
        lhs_.print();
        System.out.print(operator());
        rhs_.print();
        System.out.print(")");
    }

    

    
     /**
      * Return the type of the current node
      * return ""  if there is a problem with the operation's operands 
      * By default a binary operation only uses Integer operands
      * and the return type is Integer
     */
    public String getType() {
        String l = this.lhs_.getType();
        String r = this.rhs_.getType();
        if ((l.equals(Value.stringType))  ||   ((r.equals(Value.stringType))))  {
            System.err.println("invalid use of \""+this.operator()+"\"");// because left=" + l + " and right=" + r);
            return "";
        }

        return Value.integerType;
    }
    
    
// FIXME: Some code was deleted here (Type-check, evaluate, etc).

    // The members.
    /**right exp*/
    protected Exp lhs_;
    /**left exp */
    protected Exp rhs_;
    
    
}
