/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ast;

/**
 *
 * @author aurelien karim 
 */
public class Cond extends Exp {

    /** condition expression*/
    protected Exp e1_;
    /** then expression*/
    protected Exp e2_;
    /** else expression*/
    protected Exp e3_;

    /** Construct a Binary expression out of two expressions.*/
    public Cond(Exp e1, Exp e2, Exp e3) {
        super();
        e1_ = e1;
        e2_ = e2;
        e3_ = e3;
    }

    /** Print the ternary expression.*/
    public void print() {
        System.out.print(" if (");
        e1_.print();
        System.out.print(") then {");
        e2_.print();
        System.out.print("} else {");
        e3_.print();
        System.out.print("}");
    }

    /**
     * Eval the current node and return a value
     */
    @Override
    public Value eval() {
        if (e1_.eval().toInt() != 0) {
            return e2_.eval();
        } else {
            return e3_.eval();
        }
    }
    
        /**
     * Return the type of the current node
     * return ""  if there is a problem with the operation's operands 
     */
    @Override
    public String getType() {
        String e1 = this.e1_.getType();
        String e2 = this.e2_.getType();
        String e3 = this.e3_.getType();
        if (e1.equalsIgnoreCase("string")) {
            System.err.println("invalid use of \" if \" because Exp1 must be an Integer");
            return "";
        }

        if ((e3.equalsIgnoreCase(Value.stringType) && !e3.equals(e2)) || (e2.equalsIgnoreCase(Value.stringType) && !e2.equals(e3))) {
            System.err.println("invalid use of \" if then else\" because Exp2 and Exp3 have not the same type String or Integer");
            return "";
        }
        return e2;
    }
}
