package ast;

public class Div extends Bin {

    /** Construct a Binary expression out of two expressions.*/
    public Div(Exp lhs, Exp rhs) {
        super(lhs, rhs);
    }

    /** The string that represents the operation in concrete syntax.*/
    public String operator() {
        return "/";
    }

    /**
     * Eval the current node and return a value
     */
    public Value eval() {
        Integer den = this.rhs_.eval().toInt();
        if (den.equals(0))  throw new java.lang.ArithmeticException("division by zero");
        return new Int(this.lhs_.eval().toInt() /den );
    }

  
// FIXME: Some code was deleted here (Division).
}
