package ast;

abstract public class Ast {

    public abstract void print();

    /** eval the current ast ans return a value*/
    public abstract Value eval();

    /**Print the binary expression.*/
    public void println() {
        print();
        System.out.println();
    }

    /**
     * Return the type of the current node
     * by default it is Value.integerType
     * return ""  if there is a problem with the operation's operands 
     */
    public String getType() {
        return Value.integerType;
    }

    /**
     * Return true is the current node has a good type
     * else return false in case of error
     */
    public boolean checkType() {
        return !getType().equals("");
    }
}
