package ast;

import ast.Ast;

public abstract class Value extends Exp {

    public static final String integerType="integer";
    public static final String stringType= "string";
    
    /**The contennt's "real" value of this object*/
    protected Object val = null;

    /* Constructor of a Value*/
    public Value(Object val) {
        this.val = val;
    }

    /**
     * Eval the current node and return a value
     */
    public Value eval() {
        return this;
    }

    /**Convert the value to a java Integer*/
    public Integer toInt() {
        return (Integer) this.val;
    }

    /**Convert the value to a java String*/
    @Override
    public String toString() {
        return (String) "" + this.val;
    }
}
